/***************************************************************************
                          button.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "button.h"
#include "timer.h"
#include "config.h"

Button::Button(int _x, int _y, Menu* _men, CL_String _text) : Gui(_x, _y, _men)
{
	text=_text;
	pressed=false;
	played=false;
	activated=false;
	font=Resources::Rfont();
	type=BUTTON;
	timer=new Timer;
}
Button::~Button()
{
}
bool Button::is_pressed()
{
	return pressed;
}
bool Button::is_activated()
{
	return activated;
}
void Button::act()
{
	pressed=false;

	if((CL_Mouse::get_x()>x && CL_Mouse::get_y()>y) && (CL_Mouse::get_x()<x+get_lengt() && CL_Mouse::get_y()<y+28))
	{
		if(CL_Mouse::left_pressed()==true && (timer->time_elapsed()>0.2f))
		{
			font=Resources::Rfontg();
			if(pressed==false)
			Resources::Clickok()->play();
			pressed=true;
			timer->reset();
		}
		else
		{
			font=Resources::Rfonta();
			activated=true;
			if(played==false)
			{
				Resources::Clickcancel()->play();
				played=true;
			}	
		}
	}
	else
	{
		font=Resources::Rfont();
		played=false;
		activated=false;
	}
	
	font->print_left(x, y, text);
}
int Button::get_lengt()
{
	return text.get_length()*18;
}