/***************************************************************************
                          map.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "map.h"
#include "maptile.h"
#include "resources.h"
#include "maptile_empty.h"
#include "gameobject.h"
#include "jukebox.h"

Map::Map(WorldType _wt, Game* _game)
{
	wt=_wt;
	game=_game;
	max_m=0;
	dummy_tile=new Maptile_dummy(1024, 768, wt, this); //this should never be visible (:

	switch(wt)
	{
	  case AQUA: sur=Resources::Abackground(); break;
	  case ICE: sur=Resources::Ibackground();	 break;
	  case LAVA: sur=Resources::Lbackground();  break;
	  case JUNGLE: sur=Resources::Jbackground();	break;
	  case TECH: sur=Resources::Tbackground();  break;
	}
  Jukebox::init(wt);
}
Map::~Map()
{
}
void Map::act()
{
  list<Maptile*>::iterator it = tiles.begin();
  while (it!=tiles.end())
  {
    /* erase invalidates the iterator, so make a copy to operate on
       and increment it beforehand */
    list<Maptile*>::iterator  m=it;
    it++;
    if(!(*m)->delete_me())
      (*m)->act();
    else
    {
      tiles.erase(m);
      tiles.sort();
    }
  }
}
void Map::set_max_m(int n)
{
	max_m=n;
}
int Map::get_max_m()
{
	return max_m;
}
void Map::fit()
{
	list<Maptile*>::iterator it;
	for(it = tiles.begin(); it!=tiles.end(); ++it)
  {
    Maptile* m=*it;
	  m->fit();
  }
}
void Map::show()
{	
	sur->put_screen(frame_offset, frame_offset);
	list<Maptile*>::iterator it;	
	for(it = tiles.begin(); it!=tiles.end(); ++it)
  {
    Maptile* m=*it;
	  if(m->get_type()!=WATER && m->get_type()!=NORMAL)
	  m->show();
  }
}
void Map::show_olayer()
{
	list<Maptile*>::iterator it;
	for(it = tiles.begin(); it!=tiles.end(); ++it)
  {
    Maptile* m=*it;
	  if(m->get_type()==WATER || m->get_type()==NORMAL)
	  m->show();
  }
}
Maptile* Map::get_maptile(int _x, int _y)
{
	list<Maptile*>::iterator it;
	for(it = tiles.begin(); it!=tiles.end(); ++it)
  {
    Maptile* m=*it;
  	if(m->get_x()==_x && m->get_y()==_y)
  	return m;
  }

	return dummy_tile; //that's to avoid a segfault
}
Maptile* Map::get_up(Maptile* tile)
{
	if(tile->get_y()>32)
	return get_maptile(tile->get_x(), (tile->get_y()-32));
	else
	return dummy_tile;
}
Maptile* Map::get_down(Maptile* tile)
{
	if(tile->get_y()<672)
	return get_maptile(tile->get_x(), (tile->get_y()+32));
	else
	return dummy_tile;
}
Maptile* Map::get_left(Maptile* tile)
{
	if(tile->get_x()>32)
	return get_maptile((tile->get_x()-32), tile->get_y());
	else
	return dummy_tile;
}
Maptile* Map::get_right(Maptile* tile)
{
	if(tile->get_x()<960)
	return get_maptile((tile->get_x()+32), tile->get_y());
	else
	return dummy_tile;
}
WorldType Map::get_wt()
{
	return wt;
}